using System;
using System.Text;
using System.Text.RegularExpressions;

namespace Discuz.Common
{
    public class TypeParse
    {


        /// <summary>
        /// ж϶ǷΪInt32͵
        /// </summary>
        /// <param name="Expression"></param>
        /// <returns></returns>
        public static bool IsNumeric(object expression)
        {
            if (expression != null)
            {
                return IsNumeric(expression.ToString());
            }
            return false;

        }

        /// <summary>
        /// ж϶ǷΪInt32͵
        /// </summary>
        /// <param name="Expression"></param>
        /// <returns></returns>
        public static bool IsNumeric(string expression)
        {
            if (expression != null)
            {
                string str = expression;
                if (str.Length > 0 && str.Length <= 11 && Regex.IsMatch(str, @"^[-]?[0-9]*[.]?[0-9]*$"))
                {
                    if ((str.Length < 10) || (str.Length == 10 && str[0] == '1') || (str.Length == 11 && str[0] == '-' && str[1] == '1'))
                    {
                        return true;
                    }
                }
            }
            return false;

        }

        /// <summary>
        /// ǷΪDouble
        /// </summary>
        /// <param name="expression"></param>
        /// <returns></returns>
        public static bool IsDouble(object expression)
        {
            if (expression != null)
            {
                return Regex.IsMatch(expression.ToString(), @"^([0-9])[0-9]*(\.\w*)?$");
            }
            return false;
        }

        /// <summary>
        /// stringתΪbool
        /// </summary>
        /// <param name="strValue">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תboolͽ</returns>
        public static bool StrToBool(object expression, bool defValue)
        {
            if (expression != null)
            {
                return StrToBool(expression, defValue);
            }
            return defValue;
        }

        /// <summary>
        /// stringתΪbool
        /// </summary>
        /// <param name="strValue">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תboolͽ</returns>
        public static bool StrToBool(string expression, bool defValue)
        {
            if (expression != null)
            {
                if (string.Compare(expression, "true", true) == 0)
                {
                    return true;
                }
                else if (string.Compare(expression, "false", true) == 0)
                {
                    return false;
                }
            }
            return defValue;
        }

        /// <summary>
        /// תΪInt32
        /// </summary>
        /// <param name="strValue">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תintͽ</returns>
        public static int StrToInt(object expression, int defValue)
        {
            if (expression != null)
            {
                return StrToInt(expression.ToString(), defValue);
            }
            return defValue;
        }
    
        /// <summary>
        /// תΪInt32
        /// </summary>
        /// <param name="str">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תintͽ</returns>
        public static int StrToInt(string str, int defValue)
        {
            if (str == null)
                return defValue;
            if (str.Length > 0 && str.Length <= 11 && Regex.IsMatch(str, @"^[-]?[0-9]*$"))
            {
                if ((str.Length < 10) || (str.Length == 10 && str[0] == '1') || (str.Length == 11 && str[0] == '-' && str[1] == '1'))
                {
                    return Convert.ToInt32(str);
                }
            }
            return defValue;      
        }

        /// <summary>
        /// stringתΪfloat
        /// </summary>
        /// <param name="strValue">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תintͽ</returns>
        public static float StrToFloat(object strValue, float defValue)
        {
            if ((strValue == null))
            {
                return defValue;
            }

            return StrToFloat(strValue.ToString(), defValue);
        }

        /// <summary>
        /// stringתΪfloat
        /// </summary>
        /// <param name="strValue">Ҫתַ</param>
        /// <param name="defValue">ȱʡֵ</param>
        /// <returns>תintͽ</returns>
        public static float StrToFloat(string strValue, float defValue)
        {
            if ((strValue == null) || (strValue.Length > 10))
            {
                return defValue;
            }

            float intValue = defValue;
            if (strValue != null)
            {
                bool IsFloat = Regex.IsMatch(strValue, @"^([-]|[0-9])[0-9]*(\.\w*)?$");
                if (IsFloat)
                {
                    intValue = Convert.ToSingle(strValue);
                }
            }
            return intValue;
        }


        /// <summary>
        /// жϸַ(strNumber)еǲǶΪֵ
        /// </summary>
        /// <param name="strNumber">Ҫȷϵַ</param>
        /// <returns>򷵼true 򷵻 false</returns>
        public static bool IsNumericArray(string[] strNumber)
        {
            if (strNumber == null)
            {
                return false;
            }
            if (strNumber.Length < 1)
            {
                return false;
            }
            foreach (string id in strNumber)
            {
                if (!IsNumeric(id))
                {
                    return false;
                }
            }
            return true;

        }
    }
}
