using System;
using System.Data;
using System.Data.Common;

using Discuz.Common;
using Discuz.Data;
using Discuz.Config;
using Discuz.Entity;

namespace Discuz.Forum
{
	/// <summary>
	/// Ϣ
	/// </summary>
	public class PrivateMessages
	{
		/// <summary>
		/// ûעỶӭżû, ͬʱûע
		/// </summary>
		public const string SystemUserName = "ϵͳ";
		
		
		/// <summary>
		/// ָIDĶϢ
		/// </summary>
		/// <param name="pmid">Ϣpmid</param>
		/// <returns>Ϣ</returns>
		public static PrivateMessageInfo GetPrivateMessageInfo(int pmid)
		{
			PrivateMessageInfo __privatemessageinfo = new PrivateMessageInfo();

            IDataReader reader = DatabaseProvider.GetInstance().GetPrivateMessageInfo(pmid);
			if(reader.Read())
			{
				__privatemessageinfo.Pmid = pmid;
				__privatemessageinfo.Msgfrom = reader["msgfrom"].ToString();
				__privatemessageinfo.Msgfromid = int.Parse(reader["msgfromid"].ToString());
				__privatemessageinfo.Msgto = reader["msgto"].ToString();
				__privatemessageinfo.Msgtoid = int.Parse(reader["msgtoid"].ToString());
				__privatemessageinfo.Folder = Int16.Parse(reader["folder"].ToString());
				__privatemessageinfo.New = int.Parse(reader["new"].ToString());
				__privatemessageinfo.Subject = reader["subject"].ToString();
				__privatemessageinfo.Postdatetime = reader["postdatetime"].ToString();
				__privatemessageinfo.Message = reader["message"].ToString();
				reader.Close();
				return __privatemessageinfo;
			}
			reader.Close();
			return null;

		}


	

		/// <summary>
		/// õûĶϢ
		/// </summary>
		/// <param name="userid">ûID</param>
		/// <param name="folder">ļ(0:ռ,1:,2:ݸ)</param>
		/// <returns>Ϣ</returns>
		public static int GetPrivateMessageCount(int userid, int folder)
		{
			return GetPrivateMessageCount(userid,folder,-1);
		}

		/// <summary>
		/// õûĶϢ
		/// </summary>
		/// <param name="userid">ûID</param>
		/// <param name="folder">ļ(0:ռ,1:,2:ݸ)</param>
		/// <param name="state">Ϣ״̬(0:ѶϢ1:δϢ-1:ȫϢ)</param>
		/// <returns>Ϣ</returns>
		public static int GetPrivateMessageCount(int userid, int folder,int state)
		{
            return DatabaseProvider.GetInstance().GetPrivateMessageCount(userid, folder, state);
		}

		/// <summary>
		/// Ϣ
		/// </summary>
		/// <param name="__privatemessageinfo">Ϣ</param>
		/// <param name="savetosentbox">öϢǷڷ䱣(0Ϊ, 1Ϊ)</param>
		/// <returns>Ϣݿеpmid</returns>
		public static int CreatePrivateMessage(PrivateMessageInfo __privatemessageinfo, int savetosentbox)
		{
            return DatabaseProvider.GetInstance().CreatePrivateMessage(__privatemessageinfo, savetosentbox);    
        }


		/// <summary>
		/// ɾָûĶϢ
		/// </summary>
		/// <param name="userid">ûID</param>
		/// <param name="pmitemid">ҪɾĶϢб()</param>
		/// <returns>ɾ¼</returns>
		public static int DeletePrivateMessage(int userid, string[] pmitemid)
		{
			foreach (string id in pmitemid)
			{
				if (!Utils.IsNumeric(id))
				{
					return -1;
				}
			}

			string pmidlist = String.Join(",",pmitemid);

            int reval = DatabaseProvider.GetInstance().DeletePrivateMessages(userid, pmidlist);
            if (reval > 0)
			{
                int newpmcount = DatabaseProvider.GetInstance().GetNewPMCount(userid);
				Users.SetUserNewPMCount(userid,newpmcount);
			}

			return reval;

		}

		/// <summary>
		/// ɾָûһϢ
		/// </summary>
		/// <param name="userid">ûID</param>
		/// <param name="pmid">ҪɾĶϢID</param>
		/// <returns>ɾ¼</returns>
		public static int DeletePrivateMessage(int userid,int pmid)
		{
            int reval = DatabaseProvider.GetInstance().DeletePrivateMessage(userid, pmid);
			if (reval > 0)
			{
                int newpmcount = DatabaseProvider.GetInstance().GetNewPMCount(userid);
				Users.SetUserNewPMCount(userid,newpmcount);
			}

			return reval;

		}

		/// <summary>
		/// öϢ״̬
		/// </summary>
		/// <param name="pmid">ϢID</param>
		/// <param name="state">״ֵ̬</param>
		/// <returns>¼¼</returns>
		public static int SetPrivateMessageState(int pmid,byte state)
		{
            return DatabaseProvider.GetInstance().SetPrivateMessageState(pmid, state);
        }

#if NET1

        #region ϢϺ

        /// <summary>
        /// ָûĶϢб
        /// </summary>
        /// <param name="userid">ûID</param>
        /// <param name="folder">Ϣ(0:ռ,1:,2:ݸ)</param>
        /// <param name="pagesize">ÿҳʾϢ</param>
        /// <param name="pageindex">ǰҪʾҳ</param>
        /// <param name="strwhere">ɸѡ</param>
        /// <returns>Ϣб</returns>
	    public static PrivateMessageInfoCollection GetPrivateMessageCollection(int userid, int folder, int pagesize, int pageindex, int inttype)
        {
            PrivateMessageInfoCollection coll = new PrivateMessageInfoCollection();
            IDataReader reader = DatabaseProvider.GetInstance().GetPrivateMessageList(userid, folder, pagesize, pageindex, inttype);
            if (reader != null)
            {

                while (reader.Read())
                {
                    PrivateMessageInfo info = new PrivateMessageInfo();
                    info.Pmid = int.Parse(reader["pmid"].ToString());
                    info.Msgfrom = reader["msgfrom"].ToString();
                    info.Msgfromid = int.Parse(reader["msgfromid"].ToString());
                    info.Msgto = reader["msgto"].ToString();
                    info.Msgtoid = int.Parse(reader["msgtoid"].ToString());
                    info.Folder = Int16.Parse(reader["folder"].ToString());
                    info.New = int.Parse(reader["new"].ToString());
                    info.Subject = reader["subject"].ToString();
                    info.Postdatetime = reader["postdatetime"].ToString();
                    info.Message = reader["message"].ToString();
                    coll.Add(info);
                }
                reader.Close();
            }
            return coll;
        }



        /// <summary>
        /// ض̱ռϢб
        /// </summary>
        /// <param name="userid">ûID</param>
        /// <param name="pagesize">ÿҳʾϢ</param>
        /// <param name="pageindex">ǰҪʾҳ</param>
        /// <param name="strwhere">ɸѡ</param>
        /// <returns></returns>
        public static PrivateMessageInfoCollection GetPrivateMessageCollectionForIndex(int userid, int pagesize, int pageindex, int  inttype)
        {
            PrivateMessageInfoCollection coll = GetPrivateMessageCollection(userid, 0, pagesize, pageindex, inttype);
            if (coll.Count > 0)
            {
                for (int i = 0; i < coll.Count; i++)
                {
                    coll[i].Message = Utils.GetSubString(coll[i].Message, 20, "...");
                }

            }
            return coll;
        }

        #endregion


#else

        #region Ϣͺ

        /// <summary>
        /// ָûĶϢб
        /// </summary>
        /// <param name="userid">ûID</param>
        /// <param name="folder">Ϣ(0:ռ,1:,2:ݸ)</param>
        /// <param name="pagesize">ÿҳʾϢ</param>
        /// <param name="pageindex">ǰҪʾҳ</param>
        /// <param name="strwhere">ɸѡ</param>
        /// <returns>Ϣб</returns>
        public static Discuz.Common.Generic.List<PrivateMessageInfo> GetPrivateMessageCollection(int userid, int folder, int pagesize, int pageindex, int inttype)
        {
            Discuz.Common.Generic.List<PrivateMessageInfo> coll = new Discuz.Common.Generic.List<PrivateMessageInfo>();
            IDataReader reader = DatabaseProvider.GetInstance().GetPrivateMessageList(userid, folder, pagesize, pageindex, inttype);
            if (reader != null)
            {

                while (reader.Read())
                {
                    PrivateMessageInfo info = new PrivateMessageInfo();
                    info.Pmid = int.Parse(reader["pmid"].ToString());
                    info.Msgfrom = reader["msgfrom"].ToString();
                    info.Msgfromid = int.Parse(reader["msgfromid"].ToString());
                    info.Msgto = reader["msgto"].ToString();
                    info.Msgtoid = int.Parse(reader["msgtoid"].ToString());
                    info.Folder = Int16.Parse(reader["folder"].ToString());
                    info.New = int.Parse(reader["new"].ToString());
                    info.Subject = reader["subject"].ToString();
                    info.Postdatetime = reader["postdatetime"].ToString();
                    info.Message = reader["message"].ToString();
                    coll.Add(info);
                }
                reader.Close();
            }
            return coll;
        }



        /// <summary>
        /// ض̱ռϢб
        /// </summary>
        /// <param name="userid">ûID</param>
        /// <param name="pagesize">ÿҳʾϢ</param>
        /// <param name="pageindex">ǰҪʾҳ</param>
        /// <param name="strwhere">ɸѡ</param>
        /// <returns>ռϢб</returns>
        public static Discuz.Common.Generic.List<PrivateMessageInfo> GetPrivateMessageCollectionForIndex(int userid, int pagesize, int pageindex, int  inttype)
        {
            Discuz.Common.Generic.List<PrivateMessageInfo> coll = GetPrivateMessageCollection(userid, 0, pagesize, pageindex, inttype);
            if (coll.Count > 0)
            {
                for (int i = 0; i < coll.Count; i++)
                {
                    coll[i].Message = Utils.GetSubString(coll[i].Message, 20, "...");
                }

            }
            return coll;
        }

        #endregion

#endif

    } //class end
}
