using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Data;
using Foosun.Config;

namespace Foosun.Publish
{
    /// <summary>
    /// ǩ
    /// </summary>
    public struct LabelParameter
    {
        /// <summary>
        /// 
        /// </summary>
        public string LPName;
        /// <summary>
        /// ֵ
        /// </summary>
        public string LPValue;
    }
    /// <summary>
    /// ǩ
    /// </summary>
    public enum LabelType { Free, Custom, Class, Channel }
    /// <summary>
    /// ǩ
    /// </summary>
    public class Label
    {
        /// <summary>
        /// ǩ
        /// </summary>
        protected string _LabelName = string.Empty;
        /// <summary>
        /// ǩ
        /// </summary>
        protected LabelType _LabelType;
        /// <summary>
        /// յHTML
        /// </summary>
        protected string _FinalHtmlCode = string.Empty;
        /// <summary>
        /// ǰģ
        /// </summary>
        protected TempType _TemplateType;
        /// <summary>
        /// ǰĿID
        /// </summary>
        protected string _CurrentClassID = null;
        /// <summary>
        /// ǰרID
        /// </summary>
        protected string _CurrentSpecialID = null;
        /// <summary>
        /// ǰID
        /// </summary>
        protected string _CurrentNewsID = null;


        /// <summary>
        /// ǰƵĿID
        /// </summary>
        protected int _CurrentCHClassID;
        /// <summary>
        /// ǰƵרID
        /// </summary>
        protected int _CurrentCHSpecialID;
        /// <summary>
        /// ǰƵID
        /// </summary>
        protected int _CurrentCHNewsID;

        protected int _CurrentChID;

        //-<-wjl 2008-07-22 
        /// <summary>
        ///Ƿ
        /// </summary>
        protected bool _isConten;

        /// <summary>
        ///Ƿ
        /// </summary>
        public bool IsConten
        {
            set
            {
                this._isConten = value;
            }
            get
            {
                return _isConten;
            }
        }
        //--wjl>

        /// <summary>
        /// 캯
        /// </summary>
        /// <param name="labelname">ǩ</param>
        public Label(string labelname,LabelType labeltype)
        {
            _LabelName = labelname;
            _LabelType = labeltype;
        }
        /// <summary>
        /// ǩ
        /// </summary>
        public string LabelName
        {
            get { return _LabelName; }
        }
        /// <summary>
        /// ǩಢرǩʵ
        /// </summary>
        /// <returns>ǩͷرǩʵ</returns>
        public static Label GetLabel(string labelname)
        {
            string _labelname = labelname.ToUpper();
            if (Regex.Match( _labelname,@"\{FS_FREE_[^\}]+\}", RegexOptions.Compiled).Success)
            {
                return new FreeLabel(labelname, LabelType.Free);
            }
            else if (Regex.Match(_labelname, @"\{FS_DYN[^\}]+\}", RegexOptions.Compiled).Success)
            {
                return new DynamicLabel(labelname, LabelType.Class);
            }
            else if (Regex.Match(_labelname, @"\{FS_CH\$\d+_[^\}]+\}", RegexOptions.Compiled).Success)
            {
                string getReplaceStr = _labelname.Replace("{FS_CH$", "");
                int pLnamee = getReplaceStr.IndexOf("_");
                string FileChHTML = getReplaceStr.Substring(0, pLnamee);
                ChannelLabel chlbl = new ChannelLabel(labelname, LabelType.Channel);
                chlbl.CHID = int.Parse(FileChHTML);
                return chlbl;
            }
            else if (Regex.Match(_labelname, @"\{FS_[^\}]+\}", RegexOptions.Compiled).Success)
            {
                return new CustomLabel(labelname, LabelType.Custom);
            }
            else
            {
                throw new Exception("ǩƷǷ");
            }
        }
        /// <summary>
        /// ǰǩ
        /// </summary>
        public LabelType MyType
        {
            get { return _LabelType; }
        }
        /// <summary>
        /// ݿȡñǩ
        /// </summary>
        /// <param name="cn"></param>
        public virtual void GetContentFromDB()
        {
        }
        /// <summary>
        /// յHTML
        /// </summary>
        /// <param name="cn"></param>
        public virtual void MakeHtmlCode()
        {
        }
        /// <summary>
        /// յıǩHTML
        /// </summary>
        public string FinalHtmlCode
        {
            get { return _FinalHtmlCode; }
        }
        /// <summary>
        /// ûȡǰģ
        /// </summary>
        public TempType TemplateType
        {
            set { _TemplateType = value; }
            get { return _TemplateType; }
        }
        /// <summary>
        /// ǰĿID
        /// </summary>
        public string CurrentClassID
        {
            set { _CurrentClassID = value; }
        }
        /// <summary>
        /// ǰרID
        /// </summary>
        public string CurrentSpecialID
        {
            set { _CurrentSpecialID = value; }
        }
        /// <summary>
        /// ǰID
        /// </summary>
        public string CurrentNewsID
        {
            set { _CurrentNewsID = value; }
        }


        /// <summary>
        /// ǰƵĿID
        /// </summary>
        public int CurrentChClassID
        {
            set { _CurrentCHClassID = value; }
        }
        /// <summary>
        /// ǰƵרID
        /// </summary>
        public int CurrentCHSpecialID
        {
            set { _CurrentCHSpecialID = value; }
        }
        /// <summary>
        /// ǰƵID
        /// </summary>
        public int CurrentCHNewsID
        {
            set { _CurrentCHNewsID = value; }
        }
        /// <summary>
        /// ǰƵID
        /// </summary>
        public int CurrentChID
        {
            set { _CurrentChID = value; }
        }
    }
}
